"""autogenerated by genmsg_py from Order.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import art_msgs.msg

class Order(roslib.message.Message):
  _md5sum = "f43d538cba2d46c585cc23d97b9223b2"
  _type = "art_msgs/Order"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# commander order for the navigator
# $Id: Order.msg 615 2010-09-24 16:07:50Z jack.oquin $

uint32 N_WAYPTS = 5     		# number of way-points in order
uint32 N_CHKPTS = 2             	# number of checkpoints in order

Behavior behavior			# requested behavior
art_msgs/WayPoint[5] waypt       	# way-point array
art_msgs/WayPoint[2] chkpt       	# next two goal checkpoints
float32 min_speed			# in meters/sec
float32 max_speed
int32 replan_num
int32 next_uturn         		# Uturn between [1] and [2]

================================================================================
MSG: art_msgs/Behavior
# ART Navigator behaviors (lower numbers have higher priority)
# $Id: Behavior.msg 996 2011-02-27 16:07:34Z jack.oquin $

# enumerated behavior values
int16 Abort       = 0
int16 Quit        = 1
int16 Pause       = 2
int16 Run         = 3
int16 Suspend     = 4
int16 Initialize  = 5
int16 Go          = 6
int16 NONE        = 7
int16 N_behaviors = 8

int16 value

================================================================================
MSG: art_msgs/WayPoint
# Way-point attributes
# $Id: WayPoint.msg 614 2010-09-24 15:08:46Z jack.oquin $

float64 latitude			# latitude in degrees
float64 longitude			# longitude in degrees
geometry_msgs/Point32 mapxy		# MapXY position
MapID id				# way-point ID
uint16 index    			# parser index of waypoint

# way-point flags
bool is_entry                           # lane or zone exit point
bool is_exit				# lane or zone entry point
bool is_goal				# this is a goal checkpoint
bool is_lane_change			# change lanes after here
bool is_spot				# parking spot
bool is_stop				# stop line here
bool is_perimeter			# zone perimeter point
int32 checkpoint_id			# checkpoint ID or zero
float32 lane_width

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: art_msgs/MapID
# Road map identifier for segments, lanes and way-points.
# $Id: MapID.msg 614 2010-09-24 15:08:46Z jack.oquin $

uint16 NULL_ID = 65535

uint16 seg      # segment ID
uint16 lane     # lane ID
uint16 pt       # way-point ID

"""
  # Pseudo-constants
  N_WAYPTS = 5
  N_CHKPTS = 2

  __slots__ = ['behavior','waypt','chkpt','min_speed','max_speed','replan_num','next_uturn']
  _slot_types = ['art_msgs/Behavior','art_msgs/WayPoint[5]','art_msgs/WayPoint[2]','float32','float32','int32','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       behavior,waypt,chkpt,min_speed,max_speed,replan_num,next_uturn
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(Order, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.behavior is None:
        self.behavior = art_msgs.msg.Behavior()
      if self.waypt is None:
        self.waypt = [art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint()]
      if self.chkpt is None:
        self.chkpt = [art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint()]
      if self.min_speed is None:
        self.min_speed = 0.
      if self.max_speed is None:
        self.max_speed = 0.
      if self.replan_num is None:
        self.replan_num = 0
      if self.next_uturn is None:
        self.next_uturn = 0
    else:
      self.behavior = art_msgs.msg.Behavior()
      self.waypt = [art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint()]
      self.chkpt = [art_msgs.msg.WayPoint(),art_msgs.msg.WayPoint()]
      self.min_speed = 0.
      self.max_speed = 0.
      self.replan_num = 0
      self.next_uturn = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      buff.write(_struct_h.pack(self.behavior.value))
      for val1 in self.waypt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v1 = val1.mapxy
        _x = _v1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v2 = val1.id
        _x = _v2
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      for val1 in self.chkpt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v3 = val1.mapxy
        _x = _v3
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v4 = val1.id
        _x = _v4
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      _x = self
      buff.write(_struct_2f2i.pack(_x.min_speed, _x.max_speed, _x.replan_num, _x.next_uturn))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.behavior is None:
        self.behavior = art_msgs.msg.Behavior()
      end = 0
      start = end
      end += 2
      (self.behavior.value,) = _struct_h.unpack(str[start:end])
      self.waypt = []
      for i in xrange(0, 5):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v5 = val1.mapxy
        _x = _v5
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v6 = val1.id
        _x = _v6
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.waypt.append(val1)
      self.chkpt = []
      for i in xrange(0, 2):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v7 = val1.mapxy
        _x = _v7
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v8 = val1.id
        _x = _v8
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.chkpt.append(val1)
      _x = self
      start = end
      end += 16
      (_x.min_speed, _x.max_speed, _x.replan_num, _x.next_uturn,) = _struct_2f2i.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      buff.write(_struct_h.pack(self.behavior.value))
      for val1 in self.waypt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v9 = val1.mapxy
        _x = _v9
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v10 = val1.id
        _x = _v10
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      for val1 in self.chkpt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v11 = val1.mapxy
        _x = _v11
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v12 = val1.id
        _x = _v12
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      _x = self
      buff.write(_struct_2f2i.pack(_x.min_speed, _x.max_speed, _x.replan_num, _x.next_uturn))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.behavior is None:
        self.behavior = art_msgs.msg.Behavior()
      end = 0
      start = end
      end += 2
      (self.behavior.value,) = _struct_h.unpack(str[start:end])
      self.waypt = []
      for i in xrange(0, 5):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v13 = val1.mapxy
        _x = _v13
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v14 = val1.id
        _x = _v14
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.waypt.append(val1)
      self.chkpt = []
      for i in xrange(0, 2):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v15 = val1.mapxy
        _x = _v15
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v16 = val1.id
        _x = _v16
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.chkpt.append(val1)
      _x = self
      start = end
      end += 16
      (_x.min_speed, _x.max_speed, _x.replan_num, _x.next_uturn,) = _struct_2f2i.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_h = struct.Struct("<h")
_struct_2f2i = struct.Struct("<2f2i")
_struct_H7Bif = struct.Struct("<H7Bif")
_struct_2d = struct.Struct("<2d")
_struct_3H = struct.Struct("<3H")
_struct_3f = struct.Struct("<3f")
